diff -Nru audiofile-0.2.6/libaudiofile/wave.c audiofile-0.2.7/libaudiofile/wave.c
--- audiofile-0.2.6/libaudiofile/wave.c	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/wave.c	2010-03-22 06:42:44.000000000 +0100
@@ -30,15 +30,10 @@
 #endif
 
 #include <assert.h>
-#include <sys/types.h>
-#include <stdio.h>
+#include <math.h>
+#include <stdint.h>
 #include <stdlib.h>
 #include <string.h>
-#include <math.h>
-
-#ifdef HAVE_INTTYPES_H
-#include <inttypes.h>
-#endif
 
 #include "audiofile.h"
 #include "util.h"
@@ -49,13 +44,13 @@
 #include "setup.h"
 #include "marker.h"
 
-int _af_wave_compression_types[_AF_WAVE_NUM_COMPTYPES] =
+const int _af_wave_compression_types[_AF_WAVE_NUM_COMPTYPES] =
 {
 	AF_COMPRESSION_G711_ULAW,
 	AF_COMPRESSION_G711_ALAW
 };
 
-_InstParamInfo _af_wave_inst_params[_AF_WAVE_NUM_INSTPARAMS] =
+const _InstParamInfo _af_wave_inst_params[_AF_WAVE_NUM_INSTPARAMS] =
 {
 	{ AF_INST_MIDI_BASENOTE, AU_PVTYPE_LONG, "MIDI base note", {60} },
 	{ AF_INST_NUMCENTS_DETUNE, AU_PVTYPE_LONG, "Detune in cents", {0} },
@@ -70,9 +65,9 @@
 {
 	_AF_VALID_FILESETUP,	/* valid */
 	AF_FILE_WAVE,		/* fileFormat */
-	AF_TRUE,		/* trackSet */
-	AF_TRUE,		/* instrumentSet */
-	AF_TRUE,		/* miscellaneousSet  */
+	true,			/* trackSet */
+	true,			/* instrumentSet */
+	true,			/* miscellaneousSet  */
 	1,			/* trackCount */
 	NULL,			/* tracks */
 	0,			/* instrumentCount */
@@ -82,27 +77,27 @@
 };
 
 static status ParseFrameCount (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
-	u_int32_t	totalFrames;
+	uint32_t	totalFrames;
 	_Track		*track;
 
 	track = _af_filehandle_get_track(filehandle, AF_DEFAULT_TRACK);
 
-	af_fread(&totalFrames, 1, 4, fp);
+	af_read_uint32_le(&totalFrames, fp);
 
-	track->totalfframes = LENDIAN_TO_HOST_INT32(totalFrames);
+	track->totalfframes = totalFrames;
 
 	return AF_SUCCEED;
 }
 
 static status ParseFormat (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
 	_Track		*track;
-	u_int16_t	formatTag, channelCount;
-	u_int32_t	sampleRate, averageBytesPerSecond;
-	u_int16_t	blockAlign;
+	uint16_t	formatTag, channelCount;
+	uint32_t	sampleRate, averageBytesPerSecond;
+	uint16_t	blockAlign;
 	_WAVEInfo	*wave;
 
 	assert(filehandle != NULL);
@@ -114,23 +109,14 @@
 	assert(filehandle->formatSpecific != NULL);
 	wave = (_WAVEInfo *) filehandle->formatSpecific;
 
-	af_fread(&formatTag, 1, 2, fp);
-	formatTag = LENDIAN_TO_HOST_INT16(formatTag);
+	af_read_uint16_le(&formatTag, fp);
+	af_read_uint16_le(&channelCount, fp);
+	af_read_uint32_le(&sampleRate, fp);
+	af_read_uint32_le(&averageBytesPerSecond, fp);
+	af_read_uint16_le(&blockAlign, fp);
 
-	af_fread(&channelCount, 1, 2, fp);
-	channelCount = LENDIAN_TO_HOST_INT16(channelCount);
 	track->f.channelCount = channelCount;
-
-	af_fread(&sampleRate, 1, 4, fp);
-	sampleRate = LENDIAN_TO_HOST_INT32(sampleRate);
 	track->f.sampleRate = sampleRate;
-
-	af_fread(&averageBytesPerSecond, 1, 4, fp);
-	averageBytesPerSecond = LENDIAN_TO_HOST_INT32(averageBytesPerSecond);
-
-	af_fread(&blockAlign, 1, 2, fp);
-	blockAlign = LENDIAN_TO_HOST_INT16(blockAlign);
-
 	track->f.byteOrder = AF_BYTEORDER_LITTLEENDIAN;
 
 	/* Default to uncompressed audio data. */
@@ -140,10 +126,9 @@
 	{
 		case WAVE_FORMAT_PCM:
 		{
-			u_int16_t	bitsPerSample;
+			uint16_t	bitsPerSample;
 
-			af_fread(&bitsPerSample, 1, 2, fp);
-			bitsPerSample = LENDIAN_TO_HOST_INT16(bitsPerSample);
+			af_read_uint16_le(&bitsPerSample, fp);
 
 			track->f.sampleWidth = bitsPerSample;
 
@@ -178,10 +163,9 @@
 
 		case WAVE_FORMAT_IEEE_FLOAT:
 		{
-			u_int16_t	bitsPerSample;
+			uint16_t	bitsPerSample;
 
-			af_fread(&bitsPerSample, 1, 2, fp);
-			bitsPerSample = LENDIAN_TO_HOST_INT16(bitsPerSample);
+			af_read_uint16_le(&bitsPerSample, fp);
 
 			if (bitsPerSample == 64)
 			{
@@ -198,7 +182,7 @@
 
 		case WAVE_FORMAT_ADPCM:
 		{
-			u_int16_t	bitsPerSample, extraByteCount,
+			uint16_t	bitsPerSample, extraByteCount,
 					samplesPerBlock, numCoefficients;
 			int		i;
 			AUpvlist	pv;
@@ -213,17 +197,10 @@
 					"must have 1 or 2 channels");
 			}
 
-			af_fread(&bitsPerSample, 1, 2, fp);
-			bitsPerSample = LENDIAN_TO_HOST_INT16(bitsPerSample);
-
-			af_fread(&extraByteCount, 1, 2, fp);
-			extraByteCount = LENDIAN_TO_HOST_INT16(extraByteCount);
-
-			af_fread(&samplesPerBlock, 1, 2, fp);
-			samplesPerBlock = LENDIAN_TO_HOST_INT16(samplesPerBlock);
-
-			af_fread(&numCoefficients, 1, 2, fp);
-			numCoefficients = LENDIAN_TO_HOST_INT16(numCoefficients);
+			af_read_uint16_le(&bitsPerSample, fp);
+			af_read_uint16_le(&extraByteCount, fp);
+			af_read_uint16_le(&samplesPerBlock, fp);
+			af_read_uint16_le(&numCoefficients, fp);
 
 			/* numCoefficients should be at least 7. */
 			assert(numCoefficients >= 7 && numCoefficients <= 255);
@@ -232,11 +209,8 @@
 			{
 				int16_t	a0, a1;
 
-				af_fread(&a0, 1, 2, fp);
-				af_fread(&a1, 1, 2, fp);
-
-				a0 = LENDIAN_TO_HOST_INT16(a0);
-				a1 = LENDIAN_TO_HOST_INT16(a1);
+				af_read_uint16_le(&a0, fp);
+				af_read_uint16_le(&a1, fp);
 
 				wave->msadpcmCoefficients[i][0] = a0;
 				wave->msadpcmCoefficients[i][1] = a1;
@@ -259,7 +233,7 @@
 			v = wave->msadpcmCoefficients;
 			AUpvsetval(pv, 1, &v);
 
-			AUpvsetparam(pv, 2, _AF_SAMPLES_PER_BLOCK);
+			AUpvsetparam(pv, 2, _AF_FRAMES_PER_BLOCK);
 			AUpvsetvaltype(pv, 2, AU_PVTYPE_LONG);
 			l = samplesPerBlock;
 			AUpvsetval(pv, 2, &l);
@@ -278,17 +252,25 @@
 			AUpvlist	pv;
 			long		l;
 
-			u_int16_t	bitsPerSample, extraByteCount,
+			uint16_t	bitsPerSample, extraByteCount,
 					samplesPerBlock;
 
-			af_fread(&bitsPerSample, 1, 2, fp);
-			bitsPerSample = LENDIAN_TO_HOST_INT16(bitsPerSample);
+			af_read_uint16_le(&bitsPerSample, fp);
+			af_read_uint16_le(&extraByteCount, fp);
+			af_read_uint16_le(&samplesPerBlock, fp);
 
-			af_fread(&extraByteCount, 1, 2, fp);
-			extraByteCount = LENDIAN_TO_HOST_INT16(extraByteCount);
+			if (bitsPerSample != 4)
+			{
+				_af_error(AF_BAD_NOT_IMPLEMENTED,
+					"IMA ADPCM compression supports only 4 bits per sample");
+			}
 
-			af_fread(&samplesPerBlock, 1, 2, fp);
-			samplesPerBlock = LENDIAN_TO_HOST_INT16(samplesPerBlock);
+			int bytesPerBlock = (samplesPerBlock + 14) / 8 * 4 * channelCount;
+			if (bytesPerBlock > blockAlign || (samplesPerBlock % 8) != 1)
+			{
+				_af_error(AF_BAD_CODEC_CONFIG,
+					"Invalid samples per block for IMA ADPCM compression");
+			}
 
 			track->f.sampleWidth = 16;
 			track->f.sampleFormat = AF_SAMPFMT_TWOSCOMP;
@@ -297,7 +279,7 @@
 
 			/* Create the parameter list. */
 			pv = AUpvnew(2);
-			AUpvsetparam(pv, 0, _AF_SAMPLES_PER_BLOCK);
+			AUpvsetparam(pv, 0, _AF_FRAMES_PER_BLOCK);
 			AUpvsetvaltype(pv, 0, AU_PVTYPE_LONG);
 			l = samplesPerBlock;
 			AUpvsetval(pv, 0, &l);
@@ -341,7 +323,7 @@
 }
 
 static status ParseData (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
 	_Track	*track;
 
@@ -358,14 +340,13 @@
 }
 
 static status ParsePlayList (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
 	_Instrument	*instrument;
-	u_int32_t	segmentCount;
+	uint32_t	segmentCount;
 	int		segment;
 
-	af_fread(&segmentCount, 4, 1, fp);
-	segmentCount = LENDIAN_TO_HOST_INT32(segmentCount);
+	af_read_uint32_le(&segmentCount, fp);
 
 	if (segmentCount == 0)
 	{
@@ -376,30 +357,26 @@
 
 	for (segment=0; segment<segmentCount; segment++)
 	{
-		u_int32_t	startMarkID, loopLength, loopCount;
+		uint32_t	startMarkID, loopLength, loopCount;
 
-		af_fread(&startMarkID, 4, 1, fp);
-		startMarkID = LENDIAN_TO_HOST_INT32(startMarkID);
-		af_fread(&loopLength, 4, 1, fp);
-		loopLength = LENDIAN_TO_HOST_INT32(loopLength);
-		af_fread(&loopCount, 4, 1, fp);
-		loopCount = LENDIAN_TO_HOST_INT32(loopCount);
+		af_read_uint32_le(&startMarkID, fp);
+		af_read_uint32_le(&loopLength, fp);
+		af_read_uint32_le(&loopCount, fp);
 	}
 
 	return AF_SUCCEED;
 }
 
 static status ParseCues (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
 	_Track		*track;
-	u_int32_t	markerCount;
+	uint32_t	markerCount;
 	int		i;
 
 	track = _af_filehandle_get_track(filehandle, AF_DEFAULT_TRACK);
 
-	af_fread(&markerCount, 4, 1, fp);
-	markerCount = LENDIAN_TO_HOST_INT32(markerCount);
+	af_read_uint32_le(&markerCount, fp);
 	track->markerCount = markerCount;
 
 	if (markerCount == 0)
@@ -413,32 +390,22 @@
 
 	for (i=0; i<markerCount; i++)
 	{
-		u_int32_t	id, position, chunkid;
-		u_int32_t	chunkByteOffset, blockByteOffset;
-		u_int32_t	sampleFrameOffset;
+		uint32_t	id, position, chunkid;
+		uint32_t	chunkByteOffset, blockByteOffset;
+		uint32_t	sampleFrameOffset;
 		_Marker		*marker = &track->markers[i];
 
-		af_fread(&id, 4, 1, fp);
-		id = LENDIAN_TO_HOST_INT32(id);
-
-		af_fread(&position, 4, 1, fp);
-		position = LENDIAN_TO_HOST_INT32(position);
-
-		af_fread(&chunkid, 4, 1, fp);
-		chunkid = LENDIAN_TO_HOST_INT32(chunkid);
-
-		af_fread(&chunkByteOffset, 4, 1, fp);
-		chunkByteOffset = LENDIAN_TO_HOST_INT32(chunkByteOffset);
-
-		af_fread(&blockByteOffset, 4, 1, fp);
-		blockByteOffset = LENDIAN_TO_HOST_INT32(blockByteOffset);
+		af_read_uint32_le(&id, fp);
+		af_read_uint32_le(&position, fp);
+		af_read_uint32_le(&chunkid, fp);
+		af_read_uint32_le(&chunkByteOffset, fp);
+		af_read_uint32_le(&blockByteOffset, fp);
 
 		/*
 			sampleFrameOffset represents the position of
 			the mark in units of frames.
 		*/
-		af_fread(&sampleFrameOffset, 4, 1, fp);
-		sampleFrameOffset = LENDIAN_TO_HOST_INT32(sampleFrameOffset);
+		af_read_uint32_le(&sampleFrameOffset, fp);
 
 		marker->id = id;
 		marker->position = sampleFrameOffset;
@@ -451,7 +418,7 @@
 
 /* Parse an adtl sub-chunk within a LIST chunk. */
 static status ParseADTLSubChunk (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
 	_Track		*track;
 	AFfileoffset	endPos=af_ftell(fp)+size;
@@ -461,24 +428,21 @@
 	while (af_ftell(fp) < endPos)
 	{
 		char		chunkID[4];
-		u_int32_t	chunkSize;
+		uint32_t	chunkSize;
 
 		af_fread(chunkID, 4, 1, fp);
-		af_fread(&chunkSize, 4, 1, fp);
-		chunkSize = LENDIAN_TO_HOST_INT32(chunkSize);
+		af_read_uint32_le(&chunkSize, fp);
 
 		if (memcmp(chunkID, "labl", 4)==0 || memcmp(chunkID, "note", 4)==0)
 		{
 			_Marker *marker=NULL;
-			u_int32_t id;
+			uint32_t id;
 			long length=chunkSize-4;
 			char *p=_af_malloc(length);
 
-			af_fread(&id, 4, 1, fp);
+			af_read_uint32_le(&id, fp);
 			af_fread(p, length, 1, fp);
 
-			id = LENDIAN_TO_HOST_INT32(id);
-
 			marker = _af_marker_find_by_id(track, id);
 
 			if (marker != NULL)
@@ -517,18 +481,17 @@
 
 /* Parse an INFO sub-chunk within a LIST chunk. */
 static status ParseINFOSubChunk (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
 	AFfileoffset	endPos=af_ftell(fp)+size;
 
 	while (af_ftell(fp) < endPos)
 	{
 		int		misctype = AF_MISC_UNRECOGNIZED;
-		u_int32_t	miscid, miscsize;
+		uint32_t	miscid, miscsize;
 
 		af_fread(&miscid, 4, 1, fp);
-		af_fread(&miscsize, 4, 1, fp);
-		miscsize = LENDIAN_TO_HOST_INT32(miscsize);
+		af_read_uint32_le(&miscsize, fp);
 
 		if (memcmp(&miscid, "IART", 4) == 0)
 			misctype = AF_MISC_AUTH;
@@ -571,9 +534,9 @@
 }
 
 static status ParseList (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
-	u_int32_t	typeID;
+	uint32_t	typeID;
 
 	af_fread(&typeID, 4, 1, fp);
 	size-=4;
@@ -598,44 +561,44 @@
 }
 
 static status ParseInstrument (AFfilehandle filehandle, AFvirtualfile *fp,
-	u_int32_t id, size_t size)
+	uint32_t id, size_t size)
 {
-	u_int8_t	baseNote;
-	int8_t		detune, gain;
-	u_int8_t	lowNote, highNote, lowVelocity, highVelocity;
-	u_int8_t	padByte;
-
-	af_fread(&baseNote, 1, 1, fp);
-	af_fread(&detune, 1, 1, fp);
-	af_fread(&gain, 1, 1, fp);
-	af_fread(&lowNote, 1, 1, fp);
-	af_fread(&highNote, 1, 1, fp);
-	af_fread(&lowVelocity, 1, 1, fp);
-	af_fread(&highVelocity, 1, 1, fp);
-	af_fread(&padByte, 1, 1, fp);
+	uint8_t	baseNote;
+	int8_t	detune, gain;
+	uint8_t	lowNote, highNote, lowVelocity, highVelocity;
+	uint8_t	padByte;
+
+	af_read_uint8(&baseNote, fp);
+	af_read_uint8(&detune, fp);
+	af_read_uint8(&gain, fp);
+	af_read_uint8(&lowNote, fp);
+	af_read_uint8(&highNote, fp);
+	af_read_uint8(&lowVelocity, fp);
+	af_read_uint8(&highVelocity, fp);
+	af_read_uint8(&padByte, fp);
 
 	return AF_SUCCEED;
 }
 
 bool _af_wave_recognize (AFvirtualfile *fh)
 {
-	u_int8_t	buffer[8];
+	uint8_t	buffer[8];
 
 	af_fseek(fh, 0, SEEK_SET);
 
 	if (af_fread(buffer, 1, 8, fh) != 8 || memcmp(buffer, "RIFF", 4) != 0)
-		return AF_FALSE;
+		return false;
 	if (af_fread(buffer, 1, 4, fh) != 4 || memcmp(buffer, "WAVE", 4) != 0)
-		return AF_FALSE;
+		return false;
 
-	return AF_TRUE;
+	return true;
 }
 
 status _af_wave_read_init (AFfilesetup setup, AFfilehandle filehandle)
 {
 	_Track		*track;
-	u_int32_t	type, size, formtype;
-	u_int32_t	index = 0;
+	uint32_t	type, size, formtype;
+	uint32_t	index = 0;
 	bool		hasFormat, hasData, hasCue, hasList, hasPlayList, hasFrameCount,
 			hasINST, hasINFO;
 	_WAVEInfo	*wave = _af_malloc(sizeof (_WAVEInfo));
@@ -643,14 +606,14 @@
 	assert(filehandle != NULL);
 	assert(filehandle->fh != NULL);
 
-	hasFormat = AF_FALSE;
-	hasData = AF_FALSE;
-	hasCue = AF_FALSE;
-	hasList = AF_FALSE;
-	hasPlayList = AF_FALSE;
-	hasFrameCount = AF_FALSE;
-	hasINST = AF_FALSE;
-	hasINFO = AF_FALSE;
+	hasFormat = false;
+	hasData = false;
+	hasCue = false;
+	hasList = false;
+	hasPlayList = false;
+	hasFrameCount = false;
+	hasINST = false;
+	hasINFO = false;
 
 	filehandle->formatSpecific = wave;
 	filehandle->instruments = NULL;
@@ -665,8 +628,7 @@
 	af_fseek(filehandle->fh, 0, SEEK_SET);
 
 	af_fread(&type, 4, 1, filehandle->fh);
-	af_fread(&size, 4, 1, filehandle->fh);
-	size = LENDIAN_TO_HOST_INT32(size);
+	af_read_uint32_le(&size, filehandle->fh);
 	af_fread(&formtype, 4, 1, filehandle->fh);
 
 	assert(!memcmp(&type, "RIFF", 4));
@@ -681,16 +643,14 @@
 
 	while (index < size)
 	{
-		u_int32_t	chunkid = 0, chunksize = 0;
+		uint32_t	chunkid = 0, chunksize = 0;
 		status		result;
 
 #ifdef DEBUG
 		printf("index: %d\n", index);
 #endif
 		af_fread(&chunkid, 4, 1, filehandle->fh);
-
-		af_fread(&chunksize, 4, 1, filehandle->fh);
-		chunksize = LENDIAN_TO_HOST_INT32(chunksize);
+		af_read_uint32_le(&chunksize, filehandle->fh);
 
 #ifdef DEBUG
 		_af_printid(BENDIAN_TO_HOST_INT32(chunkid));
@@ -703,7 +663,7 @@
 			if (result == AF_FAIL)
 				return AF_FAIL;
 
-			hasFormat = AF_TRUE;
+			hasFormat = true;
 		}
 		else if (memcmp(&chunkid, "data", 4) == 0)
 		{
@@ -718,7 +678,7 @@
 			if (result == AF_FAIL)
 				return AF_FAIL;
 
-			hasData = AF_TRUE;
+			hasData = true;
 		}
 		else if (memcmp(&chunkid, "inst", 4) == 0)
 		{
@@ -728,35 +688,35 @@
 		}
 		else if (memcmp(&chunkid, "fact", 4) == 0)
 		{
-			hasFrameCount = AF_TRUE;
+			hasFrameCount = true;
 			result = ParseFrameCount(filehandle, filehandle->fh, chunkid, chunksize);
 			if (result == AF_FAIL)
 				return AF_FAIL;
 		}
 		else if (memcmp(&chunkid, "cue ", 4) == 0)
 		{
-			hasCue = AF_TRUE;
+			hasCue = true;
 			result = ParseCues(filehandle, filehandle->fh, chunkid, chunksize);
 			if (result == AF_FAIL)
 				return AF_FAIL;
 		}
 		else if (memcmp(&chunkid, "LIST", 4) == 0 || memcmp(&chunkid, "list", 4) == 0)
 		{
-			hasList = AF_TRUE;
+			hasList = true;
 			result = ParseList(filehandle, filehandle->fh, chunkid, chunksize);
 			if (result == AF_FAIL)
 				return AF_FAIL;
 		}
 		else if (memcmp(&chunkid, "INST", 4) == 0)
 		{
-			hasINST = AF_TRUE;
+			hasINST = true;
 			result = ParseInstrument(filehandle, filehandle->fh, chunkid, chunksize);
 			if (result == AF_FAIL)
 				return AF_FAIL;
 		}
 		else if (memcmp(&chunkid, "plst", 4) == 0)
 		{
-			hasPlayList = AF_TRUE;
+			hasPlayList = true;
 			result = ParsePlayList(filehandle, filehandle->fh, chunkid, chunksize);
 			if (result == AF_FAIL)
 				return AF_FAIL;
@@ -782,14 +742,10 @@
 		and a data chunk, so we can assume that track->f and
 		track->data_size have been initialized.
 	*/
-	if (hasFrameCount == AF_FALSE)
+	if (!hasFrameCount)
 	{
-		/*
-			Perform arithmetic in double-precision so as
-			to preserve accuracy.
-		*/
-		track->totalfframes = ceil((double) track->data_size /
-			_af_format_frame_size(&track->f, AF_FALSE));
+		track->totalfframes = track->data_size /
+			(int) _af_format_frame_size(&track->f, false);
 	}
 
 	if (track->f.compressionType != AF_COMPRESSION_NONE &&
@@ -834,8 +790,14 @@
 				break;
 
 			case AF_SAMPFMT_DOUBLE:
-				_af_error(AF_BAD_SAMPFMT, "WAVE format does not support double-precision floating-point data");
-				return AF_NULL_FILESETUP;
+				if (track->sampleWidthSet &&
+					track->f.sampleWidth != 64)
+				{
+					_af_error(AF_BAD_WIDTH,
+						"Warning: invalid sample width for double-precision floating-point WAVE file: %d (must be 64 bits)\n",
+						track->f.sampleWidth);
+					_af_set_sample_format(&track->f, AF_SAMPFMT_DOUBLE, 64);
+				}
 				break;
 
 			case AF_SAMPFMT_UNSIGNED:
@@ -889,7 +851,7 @@
 	*/
 	else
 	{
-		if (track->sampleWidthSet == AF_FALSE)
+		if (!track->sampleWidthSet)
 		{
 			track->f.sampleWidth = 16;
 			track->f.sampleFormat = AF_SAMPFMT_TWOSCOMP;
@@ -948,7 +910,7 @@
 		{
 			if (setup->instruments[0].loopSet &&
 				setup->instruments[0].loopCount > 0 &&
-				(track->markersSet == AF_FALSE || track->markerCount == 0))
+				(!track->markersSet || track->markerCount == 0))
 			{
 				_af_error(AF_BAD_NUMMARKS, "WAVE files with loops must contain at least 1 marker");
 				return AF_NULL_FILESETUP;
@@ -981,7 +943,7 @@
 	/*
 		Allocate an AFfilesetup and make all the unset fields correct.
 	*/
-	newsetup = _af_filesetup_copy(setup, &_af_wave_default_filesetup, AF_FALSE);
+	newsetup = _af_filesetup_copy(setup, &_af_wave_default_filesetup, false);
 
 	/* Make sure we do not copy loops if they are not specified in setup. */
 	if (setup->instrumentSet && setup->instrumentCount > 0 &&
@@ -1001,7 +963,7 @@
 	AUpvgetparam(list, i, &param);
 	AUpvgetvaltype(list, i, &type);
 	if (type != AU_PVTYPE_LONG)
-		return AF_FALSE;
+		return false;
 
 	AUpvgetval(list, i, &lval);
 
@@ -1026,11 +988,11 @@
 			return ((lval >= 0) && (lval <= 127));
 
 		case AF_INST_NUMDBS_GAIN:
-			return AF_TRUE;
+			return true;
 
 		default:
-			return AF_FALSE;
+			return false;
 	}
 
-	return AF_TRUE;
+	return true;
 }
diff -Nru audiofile-0.2.6/libaudiofile/wave.h audiofile-0.2.7/libaudiofile/wave.h
--- audiofile-0.2.6/libaudiofile/wave.h	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/wave.h	2010-03-17 06:31:21.000000000 +0100
@@ -80,7 +80,7 @@
 bool _af_wave_recognize (AFvirtualfile *fh);
 status _af_wave_read_init (AFfilesetup, AFfilehandle);
 status _af_wave_write_init (AFfilesetup, AFfilehandle);
-bool _af_wave_update (AFfilehandle);
+status _af_wave_update (AFfilehandle);
 AFfilesetup _af_wave_complete_setup (AFfilesetup);
 bool _af_wave_instparam_valid (AFfilehandle, AUpvlist, int);
 
@@ -96,11 +96,11 @@
 		The following information is specified in the format
 		chunk and is for use with compressed data formats.
 	*/
-	u_int32_t	blockAlign, samplesPerBlock;
+	uint32_t	blockAlign, samplesPerBlock;
 
 	/*
 		The index into the coefficient array is of type
-		u_int8_t, so we can safely limit msadpcmCoefficients to
+		uint8_t, so we can safely limit msadpcmCoefficients to
 		be 256 coefficient pairs.
 	*/
 	int16_t		msadpcmCoefficients[256][2];
diff -Nru audiofile-0.2.6/libaudiofile/wavewrite.c audiofile-0.2.7/libaudiofile/wavewrite.c
--- audiofile-0.2.6/libaudiofile/wavewrite.c	2004-03-06 07:39:23.000000000 +0100
+++ audiofile-0.2.7/libaudiofile/wavewrite.c	2010-03-22 06:42:51.000000000 +0100
@@ -29,15 +29,10 @@
 #include <config.h>
 #endif
 
-#include <sys/types.h>
-#include <stdio.h>
+#include <assert.h>
+#include <stdint.h>
 #include <stdlib.h>
 #include <string.h>
-#include <assert.h>
-
-#ifdef HAVE_INTTYPES_H
-#include <inttypes.h>
-#endif
 
 #include "audiofile.h"
 #include "afinternal.h"
@@ -46,8 +41,6 @@
 #include "setup.h"
 #include "wave.h"
 
-status _af_wave_update (AFfilehandle file);
-
 static status WriteFormat (AFfilehandle file);
 static status WriteFrameCount (AFfilehandle file);
 static status WriteMiscellaneous (AFfilehandle file);
@@ -71,11 +64,11 @@
 {
 	_Track		*track = NULL;
 
-	u_int16_t	formatTag, channelCount;
-	u_int32_t	sampleRate, averageBytesPerSecond;
-	u_int16_t	blockAlign;
-	u_int32_t	chunkSize;
-	u_int16_t	bitsPerSample;
+	uint16_t	formatTag, channelCount;
+	uint32_t	sampleRate, averageBytesPerSecond;
+	uint16_t	blockAlign;
+	uint32_t	chunkSize;
+	uint16_t	bitsPerSample;
 
 	assert(file != NULL);
 
@@ -87,7 +80,8 @@
 	{
 		case AF_COMPRESSION_NONE:
 			chunkSize = 16;
-			if (track->f.sampleFormat == AF_SAMPFMT_FLOAT)
+			if (track->f.sampleFormat == AF_SAMPFMT_FLOAT ||
+				track->f.sampleFormat == AF_SAMPFMT_DOUBLE)
 			{
 				formatTag = WAVE_FORMAT_IEEE_FLOAT;
 			}
@@ -102,8 +96,8 @@
 				return AF_FAIL;
 			}
 
-			blockAlign = _af_format_frame_size(&track->f, AF_FALSE);
-			bitsPerSample = 8 * _af_format_sample_size(&track->f, AF_FALSE);
+			blockAlign = _af_format_frame_size(&track->f, false);
+			bitsPerSample = 8 * _af_format_sample_size(&track->f, false);
 			break;
 
 		/*
@@ -128,38 +122,29 @@
 			return AF_FAIL;
 	}
 
-	chunkSize = HOST_TO_LENDIAN_INT32(chunkSize);
-	af_fwrite(&chunkSize, 4, 1, file->fh);
-
-	formatTag = HOST_TO_LENDIAN_INT16(formatTag);
-	af_fwrite(&formatTag, 2, 1, file->fh);
-	formatTag = LENDIAN_TO_HOST_INT16(formatTag);
+	af_write_uint32_le(&chunkSize, file->fh);
+	af_write_uint16_le(&formatTag, file->fh);
 
 	channelCount = track->f.channelCount;
-	channelCount = HOST_TO_LENDIAN_INT16(channelCount);
-	af_fwrite(&channelCount, 2, 1, file->fh);
+	af_write_uint16_le(&channelCount, file->fh);
 
 	sampleRate = track->f.sampleRate;
-	sampleRate = HOST_TO_LENDIAN_INT32(sampleRate);
-	af_fwrite(&sampleRate, 4, 1, file->fh);
+	af_write_uint32_le(&sampleRate, file->fh);
 
 	averageBytesPerSecond =
-		track->f.sampleRate * _af_format_frame_size(&track->f, AF_FALSE);
-	averageBytesPerSecond = HOST_TO_LENDIAN_INT32(averageBytesPerSecond);
-	af_fwrite(&averageBytesPerSecond, 4, 1, file->fh);
-
-	blockAlign = _af_format_frame_size(&track->f, AF_FALSE);
-	blockAlign = HOST_TO_LENDIAN_INT16(blockAlign);
-	af_fwrite(&blockAlign, 2, 1, file->fh);
+		track->f.sampleRate * _af_format_frame_size(&track->f, false);
+	af_write_uint32_le(&averageBytesPerSecond, file->fh);
+
+	blockAlign = _af_format_frame_size(&track->f, false);
+	af_write_uint16_le(&blockAlign, file->fh);
 
-	bitsPerSample = HOST_TO_LENDIAN_INT16(bitsPerSample);
-	af_fwrite(&bitsPerSample, 2, 1, file->fh);
+	af_write_uint16_le(&bitsPerSample, file->fh);
 
 	if (track->f.compressionType == AF_COMPRESSION_G711_ULAW ||
 		track->f.compressionType == AF_COMPRESSION_G711_ALAW)
 	{
-		u_int16_t	zero = 0;
-		af_fwrite(&zero, 2, 1, file->fh);
+		uint16_t	zero = 0;
+		af_write_uint16_le(&zero, file->fh);
 	}
 
 	return AF_SUCCEED;
@@ -169,16 +154,18 @@
 {
 	_Track		*track = NULL;
 	_WAVEInfo	*waveinfo = NULL;
-	u_int32_t	factSize = 4;
-	u_int32_t	totalFrameCount;
+	uint32_t	factSize = 4;
+	uint32_t	totalFrameCount;
 
 	assert(file != NULL);
 
 	track = _af_filehandle_get_track(file, AF_DEFAULT_TRACK);
 	waveinfo = (_WAVEInfo *) file->formatSpecific;
 
-	/* We only write the fact chunk for compressed audio. */
-	if (track->f.compressionType == AF_COMPRESSION_NONE)
+	/* Omit the fact chunk only for uncompressed integer audio formats. */
+	if (track->f.compressionType == AF_COMPRESSION_NONE &&
+		(track->f.sampleFormat == AF_SAMPFMT_TWOSCOMP ||
+		track->f.sampleFormat == AF_SAMPFMT_UNSIGNED))
 		return AF_SUCCEED;
 
 	/*
@@ -191,11 +178,10 @@
 		af_fseek(file->fh, waveinfo->factOffset, SEEK_SET);
 
 	af_fwrite("fact", 4, 1, file->fh);
-	factSize = HOST_TO_LENDIAN_INT32(factSize);
-	af_fwrite(&factSize, 4, 1, file->fh);
+	af_write_uint32_le(&factSize, file->fh);
 
-	totalFrameCount = HOST_TO_LENDIAN_INT32(track->totalfframes);
-	af_fwrite(&totalFrameCount, 4, 1, file->fh);
+	totalFrameCount = track->totalfframes;
+	af_write_uint32_le(&totalFrameCount, file->fh);
 
 	return AF_SUCCEED;
 }
@@ -203,7 +189,7 @@
 static status WriteData (AFfilehandle file)
 {
 	_Track		*track;
-	u_int32_t	chunkSize;
+	uint32_t	chunkSize;
 	_WAVEInfo	*waveinfo;
 
 	assert(file);
@@ -214,11 +200,10 @@
 	af_fwrite("data", 4, 1, file->fh);
 	waveinfo->dataSizeOffset = af_ftell(file->fh);
 
-	chunkSize = _af_format_frame_size(&track->f, AF_FALSE) *
+	chunkSize = (int) _af_format_frame_size(&track->f, false) *
 		track->totalfframes;
 
-	chunkSize = HOST_TO_LENDIAN_INT32(chunkSize);
-	af_fwrite(&chunkSize, 4, 1, file->fh);
+	af_write_uint32_le(&chunkSize, file->fh);
 	track->fpos_first_frame = af_ftell(file->fh);
 
 	return AF_SUCCEED;
@@ -233,7 +218,7 @@
 
 	if (track->fpos_first_frame != 0)
 	{
-		u_int32_t	dataLength, fileLength;
+		uint32_t	dataLength, fileLength;
 
 		/* Update the frame count chunk if present. */
 		WriteFrameCount(file);
@@ -245,18 +230,16 @@
 			We call _af_format_frame_size to calculate the
 			frame size of normal PCM data or compressed data.
 		*/
-		dataLength = (u_int32_t) track->totalfframes *
-			_af_format_frame_size(&track->f, AF_FALSE);
-		dataLength = HOST_TO_LENDIAN_INT32(dataLength);
-		af_fwrite(&dataLength, 4, 1, file->fh);
+		dataLength = (uint32_t) track->totalfframes *
+			(int) _af_format_frame_size(&track->f, false);
+		af_write_uint32_le(&dataLength, file->fh);
 
 		/* Update the length of the RIFF chunk. */
-		fileLength = (u_int32_t) af_flength(file->fh);
+		fileLength = (uint32_t) af_flength(file->fh);
 		fileLength -= 8;
-		fileLength = HOST_TO_LENDIAN_INT32(fileLength);
 
 		af_fseek(file->fh, 4, SEEK_SET);
-		af_fwrite(&fileLength, 4, 1, file->fh);
+		af_write_uint32_le(&fileLength, file->fh);
 	}
 
 	/*
@@ -273,7 +256,7 @@
 }
 
 /* Convert an Audio File Library miscellaneous type to a WAVE type. */
-static status misc_type_to_wave (int misctype, u_int32_t *miscid)
+static status misc_type_to_wave (int misctype, uint32_t *miscid)
 {
 	if (misctype == AF_MISC_AUTH)
 		memcpy(miscid, "IART", 4);
@@ -300,8 +283,8 @@
 	if (filehandle->miscellaneousCount != 0)
 	{
 		int		i;
-		u_int32_t	miscellaneousBytes;
-		u_int32_t 	chunkSize;
+		uint32_t	miscellaneousBytes;
+		uint32_t 	chunkSize;
 
 		/* Start at 12 to account for 'LIST', size, and 'INFO'. */
 		miscellaneousBytes = 12;
@@ -309,7 +292,7 @@
 		/* Then calculate the size of the whole INFO chunk. */
 		for (i=0; i<filehandle->miscellaneousCount; i++)
 		{
-			u_int32_t	miscid;
+			uint32_t	miscid;
 
 			/* Skip miscellaneous data of an unsupported type. */
 			if (misc_type_to_wave(filehandle->miscellaneous[i].type,
@@ -348,8 +331,7 @@
 
 		/* Write the size of the following chunk. */
 		chunkSize = miscellaneousBytes-8;
-		chunkSize = HOST_TO_LENDIAN_INT32(chunkSize);
-		af_fwrite(&chunkSize, sizeof (u_int32_t), 1, filehandle->fh);
+		af_write_uint32_le(&chunkSize, filehandle->fh);
 
 		/* Write 'INFO'. */
 		af_fwrite("INFO", 4, 1, filehandle->fh);
@@ -357,8 +339,8 @@
 		/* Write each miscellaneous chunk. */
 		for (i=0; i<filehandle->miscellaneousCount; i++)
 		{
-			u_int32_t	miscsize = HOST_TO_LENDIAN_INT32(filehandle->miscellaneous[i].size);
-			u_int32_t 	miscid = 0;
+			uint32_t	miscsize = filehandle->miscellaneous[i].size;
+			uint32_t 	miscid = 0;
 
 			/* Skip miscellaneous data of an unsupported type. */
 			if (misc_type_to_wave(filehandle->miscellaneous[i].type,
@@ -366,16 +348,16 @@
 				continue;
 
 			af_fwrite(&miscid, 4, 1, filehandle->fh);
-			af_fwrite(&miscsize, 4, 1, filehandle->fh);
+			af_write_uint32_le(&miscsize, filehandle->fh);
 			if (filehandle->miscellaneous[i].buffer != NULL)
 			{
-				u_int8_t	zero = 0;
+				uint8_t	zero = 0;
 
 				af_fwrite(filehandle->miscellaneous[i].buffer, filehandle->miscellaneous[i].size, 1, filehandle->fh);
 
 				/* Pad if necessary. */
 				if ((filehandle->miscellaneous[i].size%2) != 0)
-					af_fwrite(&zero, 1, 1, filehandle->fh);
+					af_write_uint8(&zero, filehandle->fh);
 			}
 			else
 			{
@@ -396,8 +378,7 @@
 static status WriteCues (AFfilehandle file)
 {
 	int		i, *markids, markCount;
-	u_int32_t	numCues, cueChunkSize, listChunkSize;
-	_Track		*track = &file->tracks[0];
+	uint32_t	numCues, cueChunkSize, listChunkSize;
 	_WAVEInfo	*wave;
 
 	assert(file);
@@ -420,10 +401,9 @@
 		followed by 24 bytes for each cue point record.
 	*/
 	cueChunkSize = 4 + markCount * 24;
-	cueChunkSize = HOST_TO_LENDIAN_INT32(cueChunkSize);
-	af_fwrite(&cueChunkSize, sizeof (u_int32_t), 1, file->fh);
-	numCues = HOST_TO_LENDIAN_INT32(markCount);
-	af_fwrite(&numCues, sizeof (u_int32_t), 1, file->fh);
+	af_write_uint32_le(&cueChunkSize, file->fh);
+	numCues = markCount;
+	af_write_uint32_le(&numCues, file->fh);
 
 	markids = _af_calloc(markCount, sizeof (int));
 	assert(markids != NULL);
@@ -432,15 +412,15 @@
 	/* Write each marker to the file. */
 	for (i=0; i < markCount; i++)
 	{
-		u_int32_t	identifier, position, chunkStart, blockStart;
-		u_int32_t	sampleOffset;
+		uint32_t	identifier, position, chunkStart, blockStart;
+		uint32_t	sampleOffset;
 		AFframecount	markposition;
 
-		identifier = HOST_TO_LENDIAN_INT32(markids[i]);
-		af_fwrite(&identifier, sizeof (u_int32_t), 1, file->fh);
+		identifier = markids[i];
+		af_write_uint32_le(&identifier, file->fh);
 
-		position = HOST_TO_LENDIAN_INT32(i);
-		af_fwrite(&position, sizeof (u_int32_t), 1, file->fh);
+		position = i;
+		af_write_uint32_le(&position, file->fh);
 
 		/* For now the RIFF id is always the first data chunk. */
 		af_fwrite("data", 4, 1, file->fh);
@@ -451,16 +431,16 @@
 			are zero.
 		*/
 		chunkStart = 0;
-		af_fwrite(&chunkStart, sizeof (u_int32_t), 1, file->fh);
+		af_fwrite(&chunkStart, sizeof (uint32_t), 1, file->fh);
 
 		blockStart = 0;
-		af_fwrite(&blockStart, sizeof (u_int32_t), 1, file->fh);
+		af_fwrite(&blockStart, sizeof (uint32_t), 1, file->fh);
 
 		markposition = afGetMarkPosition(file, AF_DEFAULT_TRACK, markids[i]);
 
 		/* Sample offsets are stored in the WAVE file as frames. */
-		sampleOffset = HOST_TO_LENDIAN_INT32(markposition);
-		af_fwrite(&sampleOffset, sizeof (u_int32_t), 1, file->fh);
+		sampleOffset = markposition;
+		af_write_uint32_le(&sampleOffset, file->fh);
 	}
 
 	/*
@@ -490,25 +470,23 @@
 	}
 
 	af_fwrite("LIST", 4, 1, file->fh);
-	listChunkSize = HOST_TO_LENDIAN_INT32(listChunkSize);
-	af_fwrite(&listChunkSize, sizeof (u_int32_t), 1, file->fh);
+	af_write_uint32_le(&listChunkSize, file->fh);
 	af_fwrite("adtl", 4, 1, file->fh);
 
 	for (i=0; i<markCount; i++)
 	{
 		const char	*name;
-		u_int32_t	labelSize, cuePointID;
+		uint32_t	labelSize, cuePointID;
 
 		name = afGetMarkName(file, AF_DEFAULT_TRACK, markids[i]);
 
 		/* Make labelSize even if it is not already. */
 		labelSize = 4+(strlen(name)+1) + ((strlen(name) + 1) % 2);
-		labelSize = HOST_TO_LENDIAN_INT32(labelSize);
-		cuePointID = HOST_TO_LENDIAN_INT32(markids[i]);
+		cuePointID = markids[i];
 
 		af_fwrite("labl", 4, 1, file->fh);
-		af_fwrite(&labelSize, 4, 1, file->fh);
-		af_fwrite(&cuePointID, 4, 1, file->fh);
+		af_write_uint32_le(&labelSize, file->fh);
+		af_write_uint32_le(&cuePointID, file->fh);
 		af_fwrite(name, strlen(name) + 1, 1, file->fh);
 		/*
 			If the name plus the size byte comprises an odd
@@ -517,8 +495,8 @@
 		*/
 		if (((strlen(name) + 1) % 2) != 0)
 		{
-			u_int8_t	c=0;
-			af_fwrite(&c, 1, 1, file->fh);
+			uint8_t	zero=0;
+			af_write_uint8(&zero, file->fh);
 		}
 	}
 
@@ -529,7 +507,7 @@
 
 status _af_wave_write_init (AFfilesetup setup, AFfilehandle filehandle)
 {
-	u_int32_t	zero = 0;
+	uint32_t	zero = 0;
 
 	if (_af_filesetup_make_handle(setup, filehandle) == AF_FAIL)
 		return AF_FAIL;
